(* $OpenLDAP: pkg/ldap/include/ldap.h,v 1.90 1999/12/18 18:50:38 kdz Exp $ */
/* $Novell: ldap.h,v 1.64 2003/05/13 13:46:48 $ */
/* $Novell: ldap.h,v 1.64 2003/05/13 13:46:48 $ */
/*
 * Copyright 1998-2000 The OpenLDAP Foundation, Redwood City, California, USA
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted only
 * as authorized by the OpenLDAP Public License.  A copy of this
 * license is available at http://www.OpenLDAP.org/license.html or
 * in file LICENSE in the top-level directory of the distribution.
 */
/* Portions
 * Copyright (c) 1990 Regents of the University of Michigan.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that this notice is preserved and that due credit is given
 * to the University of Michigan at Ann Arbor. The name of the University
 * may not be used to endorse or promote products derived from this
 * software without specific prior written permission. This software
 * is provided ``as is'' without express or implied warranty.
 ******************************************************************************
 * This notice applies to changes, created by or for Novell, Inc.,
 * to preexisting works for which notices appear elsewhere in this file.
 *
 *  Novell Software Developer Kit
 *
 *  Copyright (C) 2002-2003 Novell, Inc. All Rights Reserved.
 *
 *  THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND TREATIES.
 *  USE AND REDISTRIBUTION OF THIS WORK IS SUBJECT TO THE LICENSE AGREEMENT
 *  ACCOMPANYING THE SOFTWARE DEVELOPER KIT (SDK) THAT CONTAINS THIS WORK.
 *  PURSUANT TO THE SDK LICENSE AGREEMENT, NOVELL HEREBY GRANTS TO DEVELOPER A
 *  ROYALTY-FREE, NON-EXCLUSIVE LICENSE TO INCLUDE NOVELL'S SAMPLE CODE IN ITS
 *  PRODUCT. NOVELL GRANTS DEVELOPER WORLDWIDE DISTRIBUTION RIGHTS TO MARKET,
 *  DISTRIBUTE, OR SELL NOVELL'S SAMPLE CODE AS A COMPONENT OF DEVELOPER'S
 *  PRODUCTS. NOVELL SHALL HAVE NO OBLIGATIONS TO DEVELOPER OR DEVELOPER'S
 *  CUSTOMERS WITH RESPECT TO THIS CODE.
 ******************************************************************************
 * Modification to OpenLDAP source by Novell, Inc.
 * Jan 13, 2000   sfs
 * Add LIBCALL to function table to specify calling convention
 *
 * Jan 14, 2000  dks  Remove prototypes of private functions.
 *
 * Jan 20, 2000  dks  Don't advertise experimental OpenLDAP features.
 *					  LDAP_API_FEATURE_X_OPENLDAP.
 * Apr 04, 2000  sfs  Change ldap_set_rebind_func prototype
 *)
unit ldap;

interface

uses lber;

type char8 = ansichar;
     pchar8 = pansichar;

type tcmpFunc = function(const string1,string2: pchar8):integer; stdcall;
//  int (*cmp) (LDAP_CONST char *, LDAP_CONST char * )


type nuint32  = Longint; { Delphi 32-bit unsigned integer (Cardinal) is a }
                         { sub-range and is only capable of producing     }
                         { 0 .. 2147483647, where a range of              }
                         { 0..4294967295 is needed.  Because of this,     }
                         { LongInt is used to achieve this range.         }
     int32    = Integer;
     ppchar8   = ^pchar8;{ an array of pchar }

     ldapcode = int32;
type
     hLDAP   = pointer;

// ---- time.h
     timeval = record
       tv_sec : Longint;        //* seconds */
       tv_usec: Longint;        //* microseconds */
     end;
     ptimeval = ^timeval;

// ---- lber.h
//if defined(_WIN64) LBER_LEN_T		unsigned __int64
//                   LBER_SLEN_T		__int64

//* structure for returning a sequence of octet strings + length */
     berval = record
       bv_len: longint;
       bv_val: pointer;
     end;
     pberval = ^berval;

const
        LDAP_VERSION1 = 1;
        LDAP_VERSION2 = 2;
        LDAP_VERSION3 = 3;

        LDAP_VERSION_MIN = LDAP_VERSION2;
        LDAP_VERSION     = LDAP_VERSION2;
        LDAP_VERSION_MAX = LDAP_VERSION3;

///*
// * We'll use 2000+draft revision for our API version number
// * As such, the number will be above the old RFC but below
// * whatever number does finally get assigned
// */
        LDAP_API_VERSION    = 2005;
        LDAP_VENDOR_NAME    = 'Novell';
        LDAP_VENDOR_VERSION = 320;	        //* 3.1.0   October 2003 NDK */

//* OpenLDAP API Features */
//* #define LDAP_API_FEATURE_X_OPENLDAP LDAP_VENDOR_VERSION */

(*
/* include LDAP_API_FEATURE defines */
#include <ldap_features.h>

#if defined( LDAP_API_FEATURE_X_OPENLDAP_REENTRANT ) || \
	( defined( LDAP_THREAD_SAFE ) && \
		defined( LDAP_API_FEATURE_X_OPENLDAP_THREAD_SAFE ) )
	/* -lldap may or may not be thread safe */
	/* -lldap_r, if available, is always thread safe */
#	define	LDAP_API_FEATURE_THREAD_SAFE 1
#endif
#if defined( LDAP_THREAD_SAFE ) && \
	defined( LDAP_API_FEATURE_X_OPENLDAP_THREAD_SAFE )
#define LDAP_API_FEATURE_SESSION_SAFE	1
/* #define LDAP_API_OPERATION_SESSION_SAFE	1	*/
#endif
*)

        LDAP_PORT	= 389;		//* ldap:///		default LDAP port */
        LDAPS_PORT	= 636;		//* ldaps:///	default LDAP over TLS port */

        LDAP_ROOT_DSE			= '';
        LDAP_NO_ATTRS			= '1.1';
        LDAP_ALL_USER_ATTRIBUTES	= '*';
        LDAP_ALL_OPERATIONAL_ATTRIBUTES	= '+';        //* OpenLDAP extension */

///*
// * LDAP_OPTions defined by draft-ldapext-ldap-c-api-02
// * 0x0000 - 0x0fff reserved for api options
// * 0x1000 - 0x3fff reserved for api extended options
// * 0x4000 - 0x7fff reserved for private and experimental options
// */
        LDAP_OPT_API_INFO		=	$0000;
        LDAP_OPT_DESC			=	$0001; //* deprecated */
        LDAP_OPT_DEREF			=	$0002;
        LDAP_OPT_SIZELIMIT		=	$0003;
        LDAP_OPT_TIMELIMIT		=	$0004;
//* 0x05 - 0x07 not defined by current draft */
        LDAP_OPT_REFERRALS		=	$0008;
        LDAP_OPT_RESTART		=	$0009;
//* 0x0a - 0x10 not defined by current draft */
        LDAP_OPT_PROTOCOL_VERSION	=       $0011;
        LDAP_OPT_SERVER_CONTROLS	=       $0012;
        LDAP_OPT_CLIENT_CONTROLS	=       $0013;
//* 0x14 not defined by current draft */
        LDAP_OPT_API_FEATURE_INFO	=       $0015;

//* 0x16 - 0x2f not defined by current draft */
        LDAP_OPT_HOST_NAME		=	$0030;
       	LDAP_OPT_RESULT_CODE		=       $0031;	//* Updated for C API draft 5 */
       	LDAP_OPT_ERROR_NUMBER		=       $0031;
        LDAP_OPT_ERROR_STRING		=       $0032;
        LDAP_OPT_MATCHED_DN		=	$0033;
//* 0x34 - 0x0fff not defined by current draft */


//* private and experimental options */
//* OpenLDAP specific options */
        LDAP_OPT_DEBUG_LEVEL		=       $5001;	//* debug level */
        LDAP_OPT_TIMEOUT		=	$5002;	//* default timeout */
        LDAP_OPT_REFHOPLIMIT		=       $5003;	//* ref hop limit */
        LDAP_OPT_NETWORK_TIMEOUT        =       $5005;  //* socket level timeout */
        LDAP_OPT_URI			=	$5006;
        LDAP_OPT_REFERRAL_LIST          =       $5007;  //* Referrals from LDAP Result msg */

//* IO functions options */
        LDAP_OPT_IO_FUNCS        	=       $7001;

//*thread safe */
        LDAP_OPT_SESSION_REFCNT         =       $8001;

//* on/off values */
        LDAP_OPT_ON		        =       1;
        LDAP_OPT_OFF                    =       0;

///*
// * ldap_get_option() and ldap_set_option() return values.
// * As later versions may return other values indicating
// * failure, current applications should only compare returned
// * value against LDAP_OPT_SUCCESS.
// */
        LDAP_OPT_SUCCESS	=  0;
       	LDAP_OPT_ERROR		= -1;

        LDAP_API_INFO_VERSION	=  1;

(*
type
typedef struct ldapapiinfo {
	int		ldapai_info_version;		/* version of LDAPAPIInfo (1) */
	int		ldapai_api_version;			/* revision of API supported */
	int		ldapai_protocol_version;	/* highest LDAP version supported */
	char	**ldapai_extensions;		/* names of API extensions */
	char	*ldapai_vendor_name;		/* name of supplier */
	int		ldapai_vendor_version;		/* supplier-specific version * 100 */
} LDAPAPIInfo;

        LDAP_FEATURE_INFO_VERSION (1) /* version of api feature structure */
typedef struct ldap_apifeature_info {
	int		ldapaif_info_version; /* version of this struct (1) */
	char*	ldapaif_name;    /* matches LDAP_API_FEATURE_... less the prefix */
	int		ldapaif_version; /* matches the value LDAP_API_FEATURE_... */
} LDAPAPIFeatureInfo;
*)
type  LDAPControl = record
        ldctl_oid : pchar8;
        dctl_value: berval;
	ldctl_iscritical: char8;
      end;
      pLDAPControl = ^LDAPControl;
      ppLDAPControl = ^pLDAPControl;
//typedef struct ldapcontrol {
//	char *			ldctl_oid;
//	struct berval	ldctl_value;
//	char			ldctl_iscritical;
//} LDAPControl;

const
//* LDAP Controls */
	//* chase referrals controls */
        LDAP_CONTROL_REFERRALS	          = '1.2.840.113666.1.4.616';
        LDAP_CHASE_SUBORDINATE_REFERRALS  = $0020;
        LDAP_CHASE_EXTERNAL_REFERRALS	  = $0040;

        LDAP_CONTROL_MANAGEDSAIT          = '2.16.840.1.113730.3.4.2';

//* Experimental Controls */

        LDAP_CONTROL_SORTREQUEST          = '1.2.840.113556.1.4.473';
        LDAP_CONTROL_SORTRESPONSE	  = '1.2.840.113556.1.4.474';
        LDAP_CONTROL_VLVREQUEST           = '2.16.840.1.113730.3.4.9';
        LDAP_CONTROL_VLVRESPONSE          = '2.16.840.1.113730.3.4.10';
        LDAP_CONTROL_PERSISTENTSEARCH     = '2.16.840.1.113730.3.4.3';
        LDAP_CONTROL_ENTRYCHANGE          = '2.16.840.1.113730.3.4.7';

        LDAP_CONTROL_SIMPLE_PASS          = '2.16.840.1.113719.1.27.101.5';


//* LDAP Unsolicited Notifications */
       	LDAP_NOTICE_OF_DISCONNECTION      = '1.3.6.1.4.1.1466.20036';
        LDAP_NOTICE_DISCONNECT            = LDAP_NOTICE_OF_DISCONNECTION;

//* LDAP Extended Operations */
        LDAP_EXOP_START_TLS               = '1.3.6.1.4.1.1466.20037';

        LDAP_EXOP_X_MODIFY_PASSWD         = '1.3.6.1.4.1.4203.1.11.1';
        LDAP_TAG_EXOP_X_MODIFY_PASSWD_ID  = $80;
        LDAP_TAG_EXOP_X_MODIFY_PASSWD_OLD = $81;
        LDAP_TAG_EXOP_X_MODIFY_PASSWD_NEW = $82;
        LDAP_TAG_EXOP_X_MODIFY_PASSWD_GEN = $80;

//* LDAP Cancel Operations */

        LDAP_CANCEL_REQUEST               = '1.3.6.1.1.8';
(*
/*
 * specific LDAP instantiations of BER types we know about
 */

/* Overview of LBER tag construction
 *
 *	Bits
 *	______
 *	8 7 | CLASS
 *	0 0 = UNIVERSAL
 *	0 1 = APPLICATION
 *	1 0 = CONTEXT-SPECIFIC
 *	1 1 = PRIVATE
 *		_____
 *		| 6 | DATA-TYPE
 *		  0 = PRIMITIVE
 *		  1 = CONSTRUCTED
 *			___________
 *			| 5 ... 1 | TAG-NUMBER
 */

/* general stuff */
        LDAP_TAG_MESSAGE	((ber_tag_t) 0x30U)	/* constructed + 16 */
        LDAP_TAG_MSGID		((ber_tag_t) 0x02U)	/* integer */
        LDAP_TAG_LDAPDN		((ber_tag_t) 0x04U)	/* octect string */
        LDAP_TAG_LDAPCRED	((ber_tag_t) 0x04U)	/* octect string */
        LDAP_TAG_CONTROLS	((ber_tag_t) 0xa0U)	/* context specific + constructed + 0 */
        LDAP_TAG_REFERRAL	((ber_tag_t) 0xa3U)	/* context specific + constructed + 3 */

        LDAP_TAG_NEWSUPERIOR	((ber_tag_t) 0x80U)	/* context-specific + primitive + 0 */

        LDAP_TAG_EXOP_REQ_OID   ((ber_tag_t) 0x80U)	/* context specific + primitive */
        LDAP_TAG_EXOP_REQ_VALUE ((ber_tag_t) 0x81U)	/* context specific + primitive */
        LDAP_TAG_EXOP_RES_OID   ((ber_tag_t) 0x8aU)	/* context specific + primitive */
        LDAP_TAG_EXOP_RES_VALUE ((ber_tag_t) 0x8bU)	/* context specific + primitive */

        LDAP_TAG_INTERMED_RES_OID   ((ber_tag_t) 0x80U) /*context specific + primitive*/
        LDAP_TAG_INTERMED_RES_VALUE ((ber_tag_t) 0x81U) /*context specific + primitive*/
        LDAP_TAG_SASL_RES_CREDS	((ber_tag_t) 0x87U)	/* context specific + primitive */


/* possible operations a client can invoke */
        LDAP_REQ_BIND			((ber_tag_t) 0x60U)	/* application + constructed */
        LDAP_REQ_UNBIND			((ber_tag_t) 0x42U)	/* application + primitive   */
        LDAP_REQ_SEARCH			((ber_tag_t) 0x63U)	/* application + constructed */
        LDAP_REQ_MODIFY			((ber_tag_t) 0x66U)	/* application + constructed */
        LDAP_REQ_ADD			((ber_tag_t) 0x68U)	/* application + constructed */
        LDAP_REQ_DELETE			((ber_tag_t) 0x4aU)	/* application + primitive   */
        LDAP_REQ_MODDN			((ber_tag_t) 0x6cU)	/* application + constructed */
        LDAP_REQ_MODRDN			LDAP_REQ_MODDN	
        LDAP_REQ_RENAME			LDAP_REQ_MODDN	
        LDAP_REQ_COMPARE		((ber_tag_t) 0x6eU)	/* application + constructed */
        LDAP_REQ_ABANDON		((ber_tag_t) 0x50U)	/* application + primitive   */
        LDAP_REQ_EXTENDED		((ber_tag_t) 0x77U)	/* application + constructed */

/* possible result types a server can return */
        LDAP_RES_BIND			((ber_tag_t) 0x61U)	/* application + constructed */
        LDAP_RES_SEARCH_ENTRY		((ber_tag_t) 0x64U)	/* application + constructed */
        LDAP_RES_SEARCH_REFERENCE	((ber_tag_t) 0x73U)	/* V3: application + constructed */
        LDAP_RES_SEARCH_RESULT		((ber_tag_t) 0x65U)	/* application + constructed */
        LDAP_RES_MODIFY			((ber_tag_t) 0x67U)	/* application + constructed */
        LDAP_RES_ADD			((ber_tag_t) 0x69U)	/* application + constructed */
        LDAP_RES_DELETE			((ber_tag_t) 0x6bU)	/* application + constructed */
        LDAP_RES_MODDN			((ber_tag_t) 0x6dU)	/* application + constructed */
        LDAP_RES_MODRDN			LDAP_RES_MODDN	/* application + constructed */
        LDAP_RES_RENAME			LDAP_RES_MODDN	/* application + constructed */
        LDAP_RES_COMPARE		((ber_tag_t) 0x6fU)	/* application + constructed */
        LDAP_RES_EXTENDED		((ber_tag_t) 0x78U)	/* V3: application + constructed */
        LDAP_RES_EXTENDED_PARTIAL	((ber_tag_t) 0x79U)	/* V3+: application + constructed */
        LDAP_RES_INTERMEDIATE       ((ber_tag_t) 0x79U)

        LDAP_RES_ANY			(-1)
        LDAP_RES_UNSOLICITED	(0)
*)

//* sasl methods */
const
        LDAP_SASL_SIMPLE	=  0;

//* authentication methods available */
        LDAP_AUTH_NONE		= $00;  //* no authentication		  */
        LDAP_AUTH_SIMPLE	= $80;  //* context specific + primitive   */
        LDAP_AUTH_SASL		= $a3;  //* context specific + primitive   */
        LDAP_AUTH_KRBV4		= $ff;  //* means do both of the following */
        LDAP_AUTH_KRBV41	= $81;  //* context specific + primitive   */
        LDAP_AUTH_KRBV42	= $82;  //* context specific + primitive   */

//* filter types */
        LDAP_FILTER_AND		= $a0;  //* context specific + constructed */
        LDAP_FILTER_OR		= $a1;  //* context specific + constructed */
        LDAP_FILTER_NOT		= $a2;  //* context specific + constructed */
        LDAP_FILTER_EQUALITY	= $a3;  //* context specific + constructed */
        LDAP_FILTER_SUBSTRINGS	= $a4;  //* context specific + constructed */
        LDAP_FILTER_GE		= $a5;  //* context specific + constructed */
        LDAP_FILTER_LE		= $a6;  //* context specific + constructed */
        LDAP_FILTER_PRESENT	= $87;  //* context specific + primitive   */
        LDAP_FILTER_APPROX	= $a8;  //* context specific + constructed */
        LDAP_FILTER_EXT		= $a9;  //* context specific + constructed */

//* extended filter component types */
        LDAP_FILTER_EXT_OID	= $81;  //* context specific */
        LDAP_FILTER_EXT_TYPE	= $82;  //* context specific */
        LDAP_FILTER_EXT_VALUE	= $83;  //* context specific */
        LDAP_FILTER_EXT_DNATTRS	= $84;  //* context specific */

//* substring filter component types */
        LDAP_SUBSTRING_INITIAL	= $80;  //* context specific */
        LDAP_SUBSTRING_ANY	= $81;  //* context specific */
        LDAP_SUBSTRING_FINAL	= $82;  //* context specific */

//* search scopes */
        LDAP_SCOPE_DEFAULT	= -1;
        LDAP_SCOPE_BASE		= 0;
        LDAP_SCOPE_ONELEVEL	= 1;
        LDAP_SCOPE_SUBTREE	= 2;

///*
// * possible error codes we can return
// */

//      LDAP_RANGE(n,x,y)	(((x) <= (n)) && ((n) <= (y)))
const
        LDAP_SUCCESS				= $00;
        LDAP_OPERATIONS_ERROR			= $01;
        LDAP_PROTOCOL_ERROR			= $02;
        LDAP_TIMELIMIT_EXCEEDED			= $03;
        LDAP_SIZELIMIT_EXCEEDED			= $04;
        LDAP_COMPARE_FALSE			= $05;
        LDAP_COMPARE_TRUE			= $06;
        LDAP_AUTH_METHOD_NOT_SUPPORTED	        = $07;
        LDAP_STRONG_AUTH_NOT_SUPPORTED	        = LDAP_AUTH_METHOD_NOT_SUPPORTED;
        LDAP_STRONG_AUTH_REQUIRED		= $08;
        LDAP_PARTIAL_RESULTS			= $09;	//* not listed in v3 */

       	LDAP_REFERRAL				= $0a;  //* LDAPv3 */
        LDAP_ADMINLIMIT_EXCEEDED		= $0b;  //* LDAPv3 */
       	LDAP_UNAVAILABLE_CRITICAL_EXTENSION	= $0c;  //* LDAPv3 */
        LDAP_CONFIDENTIALITY_REQUIRED	        = $0d;  //* LDAPv3 */
       	LDAP_SASL_BIND_IN_PROGRESS		= $0e;  //* LDAPv3 */

//        LDAP_ATTR_ERROR(n)	LDAP_RANGE((n),0x10,0x15) /* 16-21 */

        LDAP_NO_SUCH_ATTRIBUTE		        = $10;
        LDAP_UNDEFINED_TYPE			= $11;
        LDAP_INAPPROPRIATE_MATCHING	        = $12;
        LDAP_CONSTRAINT_VIOLATION	        = $13;
        LDAP_TYPE_OR_VALUE_EXISTS	        = $14;
        LDAP_INVALID_SYNTAX			= $15;

//        LDAP_NAME_ERROR(n)	LDAP_RANGE((n),0x20,0x24) /* 32-34,36 */

        LDAP_NO_SUCH_OBJECT			= $20;
        LDAP_ALIAS_PROBLEM			= $21;
        LDAP_INVALID_DN_SYNTAX		        = $22;
        LDAP_IS_LEAF				= $23;  //* not LDAPv3 */
        LDAP_ALIAS_DEREF_PROBLEM	        = $24;

//        LDAP_SECURITY_ERROR(n)	LDAP_RANGE((n),0x30,0x32) /* 48-50 */

        LDAP_INAPPROPRIATE_AUTH	         	= $30;
        LDAP_INVALID_CREDENTIALS	        = $31;
        LDAP_INSUFFICIENT_ACCESS	        = $32;

//        LDAP_SERVICE_ERROR(n)	LDAP_RANGE((n),0x33,0x36) /* 51-54 */

        LDAP_BUSY			     	= $33;
        LDAP_UNAVAILABLE			= $34;
        LDAP_UNWILLING_TO_PERFORM	        = $35;
        LDAP_LOOP_DETECT			= $36;

//        LDAP_UPDATE_ERROR(n)	LDAP_RANGE((n),0x40,0x47) /* 64-69,71 */

        LDAP_NAMING_VIOLATION	                = $40;
        LDAP_OBJECT_CLASS_VIOLATION             = $41;
        LDAP_NOT_ALLOWED_ON_NONLEAF	        = $42;
        LDAP_NOT_ALLOWED_ON_RDN		        = $43;
        LDAP_ALREADY_EXISTS			= $44;
        LDAP_NO_OBJECT_CLASS_MODS	        = $45;
        LDAP_RESULTS_TOO_LARGE		        = $46;  //* CLDAP */
        LDAP_AFFECTS_MULTIPLE_DSAS	        = $47;  //* LDAPv3 */

        LDAP_OTHER				= $50;

//        LDAP_API_ERROR(n)		LDAP_RANGE((n),0x51,0x61) /* 81-97 */

        LDAP_SERVER_DOWN		= $51;
        LDAP_LOCAL_ERROR		= $52;
        LDAP_ENCODING_ERROR		= $53;
        LDAP_DECODING_ERROR		= $54;
        LDAP_TIMEOUT			= $55;
        LDAP_AUTH_UNKNOWN		= $56;
        LDAP_FILTER_ERROR		= $57;
        LDAP_USER_CANCELLED		= $58;
        LDAP_PARAM_ERROR		= $59;
        LDAP_NO_MEMORY			= $5a;

//* not technically reserved for APIs */
        LDAP_CONNECT_ERROR		= $5b;	//* draft-ietf-ldap-c-api-xx */
        LDAP_NOT_SUPPORTED		= $5c;	//* draft-ietf-ldap-c-api-xx */
        LDAP_CONTROL_NOT_FOUND		= $5d;	//* draft-ietf-ldap-c-api-xx */
        LDAP_NO_RESULTS_RETURNED	= $5e;	//* draft-ietf-ldap-c-api-xx */
        LDAP_MORE_RESULTS_TO_RETURN	= $5f;	//* draft-ietf-ldap-c-api-xx */
        LDAP_CLIENT_LOOP		= $60;	//* draft-ietf-ldap-c-api-xx */
        LDAP_REFERRAL_LIMIT_EXCEEDED	= $61;	//* draft-ietf-ldap-c-api-xx */

//* LDAP Cancel operation */
        LDAP_CANCELED			= $76;
        LDAP_CANCEL_NO_SUCH_OPERATION	= $77;
        LDAP_CANCEL_TOO_LATE		= $78;
        LDAP_CANCEL_CANNOT_CANCEL	= $79;

///*
// * This structure represents both ldap messages and ldap responses.
// * These are really the same, except in the case of search responses,
// * where a response has multiple messages.
// */
type
     LDAPMessage = pointer;
(*

/* for modifications */
typedef union mod_vals_u {			   /* Novell: Updated for C API draft 5 */
	char		**modv_strvals;
	struct berval	**modv_bvals;
} mod_vals_u_t;
*)
const
        LDAP_MOD_ADD		= $0000;
        LDAP_MOD_DELETE		= $0001;
        LDAP_MOD_REPLACE	= $0002;
        LDAP_MOD_BVALUES	= $0080;
type
        LDAPMod = record
          mod_op    : int32;
          mod_type  : pchar8;
          mod_values: pointer;
        end;
        pLDAPMod = ^LDAPMod;
        ppLDAPMod = ^pLDAPMod;  // points to an array of LDAPMod
(*
typedef struct ldapmod {
	int		mod_op;

        LDAP_MOD_ADD		((ber_int_t) 0x0000)
        LDAP_MOD_DELETE		((ber_int_t) 0x0001)
        LDAP_MOD_REPLACE	((ber_int_t) 0x0002)
        LDAP_MOD_BVALUES	((ber_int_t) 0x0080)
/* IMPORTANT: do not use code 0x1000 (or above),
 * it is used internally by the backends!
 * (see ldap/servers/slapd/slap.h)
 */

	char		*mod_type;
	mod_vals_u_t	mod_vals;
        mod_values	mod_vals.modv_strvals
        mod_bvalues	mod_vals.modv_bvals
} LDAPMod;

/*
 * structures for ldap getfilter routines
 */

typedef struct ldap_filt_info {
	char		*lfi_filter;
	char		*lfi_desc;
	int			lfi_scope;
	int			lfi_isexact;
	struct ldap_filt_info	*lfi_next;
} LDAPFiltInfo;

typedef struct ldap_filt_list {
    char			*lfl_tag;
    char			*lfl_pattern;
    char			*lfl_delims;
    LDAPFiltInfo	*lfl_ilist;
    struct ldap_filt_list	*lfl_next;
} LDAPFiltList;


        LDAP_FILT_MAXSIZ	1024

typedef struct ldap_filt_desc {
	LDAPFiltList	*lfd_filtlist;
	LDAPFiltInfo	*lfd_curfip;
	LDAPFiltInfo	lfd_retfi;
	char			lfd_filter[ LDAP_FILT_MAXSIZ ];
	char			*lfd_curval;
	char			*lfd_curvalcopy;
	char			**lfd_curvalwords;
	char			*lfd_filtprefix;
	char			*lfd_filtsuffix;
} LDAPFiltDesc;

*)
///*
// * structure representing an ldap session which can
// * encompass connections to multiple servers (in the
// * face of referrals).
// */
//typedef struct ldap LDAP; -> hLDAP : pointer
const
        LDAP_DEREF_NEVER	=  0;
        LDAP_DEREF_SEARCHING	=  1;
        LDAP_DEREF_FINDING	=  2;
        LDAP_DEREF_ALWAYS	=  3;

        LDAP_NO_LIMIT		=  0;
        LDAP_DEFAULT_SIZELIMIT  = -1;

//* how many messages to retrieve results for */
        LDAP_MSG_ONE		= 0;
        LDAP_MSG_ALL		= 1;
        LDAP_MSG_RECEIVED	= 2;

(*
/*
 * structure for ldap friendly mapping routines
 */

typedef struct ldap_friendly {
	char	*lf_unfriendly;
	char	*lf_friendly;
} LDAPFriendlyMap;

/*
 * types for ldap URL handling
 */
typedef struct ldap_url_desc {
	struct ldap_url_desc *lud_next;
	char	*lud_scheme;
	char	*lud_host;
	int		lud_port;
	char	*lud_dn;
	char	**lud_attrs;
	int		lud_scope;
	char	*lud_filter;
	char	**lud_exts;
	int		lud_crit_exts;
} LDAPURLDesc;
*)
const
        LDAP_URL_SUCCESS		= $00;	//* Success */
        LDAP_URL_ERR_MEM		= $01;	//* can't allocate memory space */
        LDAP_URL_ERR_PARAM		= $02;	//* parameter is bad */

        LDAP_URL_ERR_BADSCHEME	        = $03;	//* URL doesn't begin with "ldap[si]://" */
        LDAP_URL_ERR_BADENCLOSURE       = $04;	//* URL is missing trailing ">" */
        LDAP_URL_ERR_BADURL		= $05;	//* URL is bad */
        LDAP_URL_ERR_BADHOST	        = $06;	//* host port is bad */
        LDAP_URL_ERR_BADATTRS	        = $07;	//* bad (or missing) attributes */
        LDAP_URL_ERR_BADSCOPE	        = $08;	//* scope string is invalid (or missing) */
        LDAP_URL_ERR_BADFILTER	        = $09;	//* bad or missing filter */
        LDAP_URL_ERR_BADEXTS	        = $0a;	//* bad or missing extensions */


///*
// *  IO functions structure
// */
(*
type
typedef struct ldap_io_funcs {
	ber_socket_t (LIBCALL *io_socket) ( int, int, int, LDAP * );
	int   (LIBCALL *io_prepare)  ( ber_socket_t, LDAP * );
	int   (LIBCALL *io_connect)  ( ber_socket_t, struct sockaddr *, int, LDAP * );
	int   (LIBCALL *io_read)     ( ber_socket_t, void *, ber_len_t, LDAP * );
	int   (LIBCALL *io_write)    ( ber_socket_t, void *, ber_len_t, LDAP * );
#ifdef HAVE_POLL
	int   (LIBCALL *io_select)   ( int, struct pollfd *, fd_set *, fd_set *, struct timeval *, LDAP * );
#else
	int   (LIBCALL *io_select)   ( int, fd_set *, fd_set *, fd_set *, struct timeval *, LDAP * );
#endif
	int   (LIBCALL *io_ioctl)    ( ber_socket_t, long, void *, LDAP * );
	int   (LIBCALL *io_close)    ( ber_socket_t, LDAP * );
	} LDAPIOFuncs;

*)
///*
// * in loptions.c:
// */

function ldap_get_option(
           ld: hLDAP;
           option: int32;
           outvalue: POINTER):ldapcode; stdcall;
//LDAP_F( int )
//ldap_get_option LDAP_P((
//	LDAP *ld,
//	int option,
//	void *outvalue));

function ldap_set_option(
           ld: hLDAP;
           option: int32;
           VAR invalue):ldapcode; stdcall;
//LDAP_F( int )
//ldap_set_option LDAP_P((
//	LDAP *ld,
//	int option,
//	LDAP_CONST void *invalue));

(*        
/* V3 REBIND Function Callback Prototype */
typedef int (LIBCALL LDAP_REBIND_PROC) LDAP_P((
	LDAP *ld, LDAP_CONST char *url, int request, ber_int_t msgid ));

LDAP_F( int )
ldap_set_rebind_proc LDAP_P((
	LDAP *ld,
	LDAP_REBIND_PROC *ldap_proc));

/*
 * in controls.c:
 */
LDAP_F( void )
ldap_control_free LDAP_P((
	LDAPControl *ctrl ));

LDAP_F( void )
ldap_controls_free LDAP_P((
	LDAPControl **ctrls ));

  
/*
 * in extended.c:
 */
LDAP_F( int )
ldap_extended_operation LDAP_P((
	LDAP			*ld,
	LDAP_CONST char	*reqoid,
	struct berval	*reqdata,
	LDAPControl		**serverctrls,
	LDAPControl		**clientctrls,
	int				*msgidp ));

LDAP_F( int )
ldap_extended_operation_s LDAP_P((
	LDAP			*ld,
	LDAP_CONST char	*reqoid,
	struct berval	*reqdata,
	LDAPControl		**serverctrls,
	LDAPControl		**clientctrls,
	char			**retoidp,
	struct berval	**retdatap ));

LDAP_F( int )
ldap_parse_extended_result LDAP_P((
	LDAP			*ld,
	LDAPMessage		*res,
	char			**retoidp,
	struct berval	**retdatap,
	int				freeit ));

LDAP_F( int )
ldap_parse_intermediate LDAP_P((
	LDAP			*ld,
	LDAPMessage		*res,
	char			**retoidp,
	struct berval	**retdatap,
	LDAPControl		***serverctrls,
	int				freeit ));

/*
 * in abandon.c:
 */
LDAP_F( int )
ldap_abandon_ext LDAP_P((
	LDAP			*ld,
	int				msgid,
	LDAPControl		**serverctrls,
	LDAPControl		**clientctrls ));

LDAP_F( int )
ldap_abandon LDAP_P((	/* deprecated */
	LDAP *ld,
	int msgid ));
*)

///*
// * in add.c:
// */
function ldap_add_ext(
           ld: hLDAP;
	         dn: pchar8;
           attrs: ppLDAPMod;
           serverctrls: ppLDAPControl;
           clientctrls: ppLDAPControl;
           var sgidp: int32):ldapcode; stdcall;
//LDAP_F( int )
//ldap_add_ext LDAP_P((
//	LDAP			*ld,
//	LDAP_CONST char	*dn,
//	LDAPMod			**attrs,
//	LDAPControl		**serverctrls,
//	LDAPControl		**clientctrls,
//	int 			*msgidp ));

function ldap_add_ext_s(
           ld: hLDAP;
	         dn: pchar8;
           attrs: ppLDAPMod;
           serverctrls: ppLDAPControl;
           clientctrls: ppLDAPControl):ldapcode; stdcall;
//LDAP_F( int )
//ldap_add_ext_s LDAP_P((
//	LDAP			*ld,
//	LDAP_CONST char	*dn,
//	LDAPMod			**attrs,
//	LDAPControl		**serverctrls,
//	LDAPControl		**clientctrls ));

//LDAP_F( int )
//ldap_add LDAP_P((	/* deprecated */
//	LDAP *ld,
//	LDAP_CONST char *dn,
//	LDAPMod **attrs ));

//LDAP_F( int )
//ldap_add_s LDAP_P((	/* deprecated */
//	LDAP *ld,
//	LDAP_CONST char *dn,
//	LDAPMod **attrs ));

(*
/*
 * in sasl.c:
 */
LDAP_F( int )
ldap_sasl_bind LDAP_P((
	LDAP			*ld,
	LDAP_CONST char	*dn,
	LDAP_CONST char	*mechanism,
	struct berval	*cred,
	LDAPControl		**serverctrls,
	LDAPControl		**clientctrls,
	int				*msgidp ));
*)
function ldap_sasl_bind_s(
           ld: hLDAP;
           dn: pchar8;
           mechanism: pchar8;
           var cred: berval;
           serverctrls: ppLDAPControl;
           clientctrls: ppLDAPControl;
           var servercredp: pberval):ldapcode; stdcall;
//LDAP_F( int )
//ldap_sasl_bind_s LDAP_P((
//	LDAP			*ld,
//	LDAP_CONST char	*dn,
//	LDAP_CONST char	*mechanism,
//	struct berval	*cred,
//	LDAPControl		**serverctrls,
//	LDAPControl		**clientctrls,
//	struct berval	**servercredp ));

function ldap_parse_sasl_bind_result(
	ld: hLDAP;
	res: LDAPMessage;
        var servercredp: pberval;
	freeit: integer):ldapcode; stdcall;
//LDAP_F( int )
//ldap_parse_sasl_bind_result LDAP_P((
//	LDAP			*ld,
//	LDAPMessage		*res,
//	struct berval	**servercredp,
//	int				freeit ));
(*
/*
 * in bind.c:
 *	(deprecated)
 */
LDAP_F( int )
ldap_bind LDAP_P((	/* deprecated */
	LDAP *ld,
	LDAP_CONST char *who,
	LDAP_CONST char *passwd,
	int authmethod ));

LDAP_F( int )
ldap_bind_s LDAP_P((	/* deprecated */
	LDAP *ld,
	LDAP_CONST char *who,
	LDAP_CONST char *cred,
	int authmethod ));
*)
///*
// * in sbind.c:
// */
function ldap_simple_bind(
           ld: hLDAP;
           who: pchar8;
           passwd: pchar8):ldapcode; stdcall;
//LDAP_F( int )
//ldap_simple_bind LDAP_P((
//	LDAP *ld,
//	LDAP_CONST char *who,
//	LDAP_CONST char *passwd ));

function ldap_simple_bind_s(
           ld: hLDAP;
           who: pchar8;
           passwd: pchar8):ldapcode; stdcall;
//LDAP_F( int )
//ldap_simple_bind_s LDAP_P((
//	LDAP *ld,
//	LDAP_CONST char *who,
//	LDAP_CONST char *passwd ));

(*
/*
 * in compare.c:
 */
LDAP_F( int )
ldap_compare_ext LDAP_P((
	LDAP			*ld,
	LDAP_CONST char	*dn,
	LDAP_CONST char	*attr,
	struct berval	*bvalue,
	LDAPControl		**serverctrls,
	LDAPControl		**clientctrls,
	int 			*msgidp ));

LDAP_F( int )
ldap_compare_ext_s LDAP_P((
	LDAP			*ld,
	LDAP_CONST char	*dn,
	LDAP_CONST char	*attr,
	struct berval	*bvalue,
	LDAPControl		**serverctrls,
	LDAPControl		**clientctrls ));

LDAP_F( int )
ldap_compare LDAP_P((	/* deprecated */
	LDAP *ld,
	LDAP_CONST char *dn,
	LDAP_CONST char *attr,
	LDAP_CONST char *value ));

LDAP_F( int )
ldap_compare_s LDAP_P((	/* deprecated */
	LDAP *ld,
	LDAP_CONST char *dn,
	LDAP_CONST char *attr,
	LDAP_CONST char *value ));


/*
 * in delete.c:
 */
*)

//LDAP_F( int )
//ldap_delete_ext LDAP_P((
//	LDAP		*ld,
//	LDAP_CONST char	*dn,
//	LDAPControl	**serverctrls,
//	LDAPControl	**clientctrls,
//	int 		*msgidp ));
function ldap_delete_ext(
           ld: hLDAP;
           dn: pchar8;
           serverctrls: ppLDAPControl;
           clientctrls: ppLDAPControl;
           var msgidp: int32):ldapcode; stdcall;
//LDAP_F( int )
//ldap_delete_ext_s LDAP_P((
//	LDAP		*ld,
//	LDAP_CONST char	*dn,
//	LDAPControl	**serverctrls,
//	LDAPControl	**clientctrls ));
function ldap_delete_ext_s(
           ld: hLDAP;
           dn: pchar8;
           serverctrls: ppLDAPControl;
           clientctrls: ppLDAPControl):ldapcode; stdcall;
//LDAP_F( int )
//ldap_delete LDAP_P((  	/* deprecated */
//	LDAP *ld,
//	LDAP_CONST char *dn ));

//LDAP_F( int )
//ldap_delete_s LDAP_P((	/* deprecated */
//	LDAP *ld,
//	LDAP_CONST char *dn ));

(*
/*
 * in error.c:
 */
LDAP_F( int )
ldap_parse_result LDAP_P((
	LDAP			*ld,
	LDAPMessage		*res,
	int			*errcodep,
	char			**matcheddnp,
	char			**errmsgp,
	char			***referralsp,
	LDAPControl		***serverctrls,
	int			freeit ));
*)

function ldap_err2string(
           err: int32):pchar8; stdcall;
//LDAP_F( char * )
//ldap_err2string LDAP_P((
//	int err ));

(*
LDAP_F( int )
ldap_result2error LDAP_P((	/* deprecated */
	LDAP *ld,
	LDAPMessage *r,
	int freeit ));

LDAP_F( void )
ldap_perror LDAP_P((	/* deprecated */
	LDAP *ld,
	LDAP_CONST char *s ));


/*
 * in lderrno.c:   Addition by Novell for compatibility
 */

LDAP_F(int)					/* deprecated */
ldap_get_lderrno( LDAP *ld, char **matchedDN, char **errmsg );

LDAP_F(int)                  /* deprecated */
ldap_set_lderrno( LDAP *ld, int errnum, char *matchedDN, char *errmsg );
*)

///*
// * in modify.c:
// */
function ldap_modify_ext(
           ld: hLDAP;
           dn: pchar8;
           mods: ppLDAPMod;
           serverctrls: ppLDAPControl;
           clientctrls: ppLDAPControl;
           var msgidp: int32):ldapcode; stdcall;
//LDAP_F( int )
//ldap_modify_ext LDAP_P((
//	LDAP			*ld,
//	LDAP_CONST char	        *dn,
//	LDAPMod			**mods,
//	LDAPControl		**serverctrls,
//	LDAPControl		**clientctrls,
//	int 			*msgidp ));
function ldap_modify_ext_s(
           ld: hLDAP;
           dn: pchar8;
           mods: ppLDAPMod;
           serverctrls: ppLDAPControl;
           clientctrls: ppLDAPControl):ldapcode; stdcall;
//LDAP_F( int )
//ldap_modify_ext_s LDAP_P((
//	LDAP			*ld,
//	LDAP_CONST char	*dn,
//	LDAPMod			**mods,
//	LDAPControl		**serverctrls,
//	LDAPControl		**clientctrls ));

//LDAP_F( int )
//ldap_modify LDAP_P((	/* deprecated */
//	LDAP *ld,
//	LDAP_CONST char *dn,
//	LDAPMod **mods ));

//LDAP_F( int )
//ldap_modify_s LDAP_P((	/* deprecated */
//	LDAP *ld,
//	LDAP_CONST char *dn,
//	LDAPMod **mods ));

///*
// * in modrdn.c:
// */
function ldap_rename(
           ld: hLDAP;
           dn: pchar8;
           newrdn: pchar8;
           newSuperior: pchar8;
           deleteoldrdn: longbool;
           sctrls: ppLDAPControl;
           cctrls: ppLDAPControl;
           var msgidp: int32):ldapcode; stdcall;
//LDAP_F( int )
//ldap_rename LDAP_P((
//	LDAP *ld,
//	LDAP_CONST char *dn,
//	LDAP_CONST char *newrdn,
//	LDAP_CONST char *newSuperior,
//	int deleteoldrdn,
//	LDAPControl **sctrls,
//	LDAPControl **cctrls,
//	int *msgidp ));
//
function ldap_rename_s(
           ld: hLDAP;
           dn: pchar8;
           newrdn: pchar8;
           newSuperior: pchar8;    { newParent }
           deleteoldrdn: longbool;
           sctrls: ppLDAPControl;
           cctrls: ppLDAPControl):ldapcode; stdcall;
//LDAP_F( int )
//ldap_rename_s LDAP_P((
//	LDAP *ld,
//	LDAP_CONST char *dn,
//	LDAP_CONST char *newrdn,
//	LDAP_CONST char *newSuperior,
//	int deleteoldrdn,
//	LDAPControl **sctrls,
//	LDAPControl **cctrls ));
//
(*
LDAP_F( int )
ldap_modrdn LDAP_P((	/* deprecated */
	LDAP *ld,
	LDAP_CONST char *dn,
	LDAP_CONST char *newrdn ));

LDAP_F( int )
ldap_modrdn_s LDAP_P((	/* deprecated */
	LDAP *ld,
	LDAP_CONST char *dn,
	LDAP_CONST char *newrdn ));

LDAP_F( int )
ldap_modrdn2 LDAP_P((	/* deprecated */
	LDAP *ld,
	LDAP_CONST char *dn,
	LDAP_CONST char *newrdn,
	int deleteoldrdn ));

LDAP_F( int )
ldap_modrdn2_s LDAP_P((	/* deprecated */
	LDAP *ld,
	LDAP_CONST char *dn,
	LDAP_CONST char *newrdn,
	int deleteoldrdn));

*)
///*
// * in open.c:
// */
function ldap_init(
           host: pchar8;
           port: int32):hLDAP; stdcall;
//LDAP_F( LDAP * )
//ldap_init LDAP_P((
//	LDAP_CONST char *host,
//	int port ));

//LDAP_F( LDAP * )
//ldap_open LDAP_P((	/* deprecated */
//	LDAP_CONST char *host,
//	int port ));

function ldap_destroy(
           ld: hLDAP):int32; stdcall;
//LDAP_F( int )
//ldap_destroy LDAP_P((
//	LDAP *ld));

function ldap_dup(
           ld: hLDAP):hLDAP; stdcall;
//LDAP_F(LDAP * )
//ldap_dup LDAP_P((
//	LDAP *ld));

(*
/*
 * in messages.c:
 */
LDAP_F( LDAPMessage * )
ldap_first_message LDAP_P((
	LDAP *ld,
	LDAPMessage *chain ));

LDAP_F( LDAPMessage * )
ldap_next_message LDAP_P((
	LDAP *ld,
	LDAPMessage *msg ));

LDAP_F( int )
ldap_count_messages LDAP_P((
	LDAP *ld,
	LDAPMessage *chain ));


/*
 * in references.c:
 */
LDAP_F( LDAPMessage * )
ldap_first_reference LDAP_P((
	LDAP *ld,
	LDAPMessage *chain ));

LDAP_F( LDAPMessage * )
ldap_next_reference LDAP_P((
	LDAP *ld,
	LDAPMessage *ref ));

LDAP_F( int )
ldap_count_references LDAP_P((
	LDAP *ld,
	LDAPMessage *chain ));

LDAP_F( int )
ldap_parse_reference LDAP_P((
	LDAP			*ld,
	LDAPMessage		*ref,
	char			***referralsp,
	LDAPControl		***serverctrls,
	int				freeit));

*)
///*
// * in getentry.c:
// */
function ldap_first_entry(
           ld: hLDAP;
           chain: LDAPMessage):LDAPMessage; stdcall;
//LDAP_F( LDAPMessage * )
//ldap_first_entry LDAP_P((
//	LDAP *ld,
//	LDAPMessage *chain ));

function ldap_next_entry(
           ld: hLDAP;
           entry: LDAPMessage):LDAPMessage; stdcall;
//LDAP_F( LDAPMessage * )
//ldap_next_entry LDAP_P((
//	LDAP *ld,
//	LDAPMessage *entry ));

function ldap_count_entries(
           ld: hLDAP;
           chain: LDAPMessage):int32; stdcall;
//LDAP_F( int )
//ldap_count_entries LDAP_P((
//	LDAP *ld,
//	LDAPMessage *chain ));

function ldap_get_entry_controls(
           ld: hLDAP;
           chain: LDAPMessage;
           serverctrls: ppLDAPControl):int32; stdcall;
//LDAP_F( int )
//ldap_get_entry_controls LDAP_P((
//	LDAP			*ld,
//	LDAPMessage		*entry,
//	LDAPControl		***serverctrls));


///*
// * in getdn.c
// */
function ldap_get_dn(
           ld: hLDAP;
           entry: LDAPMessage):pchar8; stdcall;
//LDAP_F( char * )
//ldap_get_dn LDAP_P((
//	LDAP *ld,
//	LDAPMessage *entry ));

function ldap_dn2ufn(
           dn: pchar8):pchar8; stdcall;
//LDAP_F( char * )
//ldap_dn2ufn LDAP_P((
//	LDAP_CONST char *dn ));

// ldap_ufn2dn() not implemented in Library

function ldap_explode_dn(
           dn: pchar8;
           notypes: int32):ppchar8; stdcall;
//LDAP_F( char ** )
//ldap_explode_dn LDAP_P((
//	LDAP_CONST char *dn,
//	int notypes ));

function ldap_explode_rdn(
           dn: pchar8;
           notypes: int32):ppchar8; stdcall;
//LDAP_F( char ** )
//ldap_explode_rdn LDAP_P((
//	LDAP_CONST char *rdn,
//	int notypes ));

///*
// * in getattr.c
// */
function ldap_first_attribute(
           ld: hLDAP;
           entry : LDAPMessage;
           VAR ber: BerElement): pchar8; stdcall;
//LDAP_F( char * )
//ldap_first_attribute LDAP_P((
//	LDAP *ld,
//	LDAPMessage *entry,
//	BerElement **ber ));

function ldap_next_attribute(
           ld: hLDAP;
           entry : LDAPMessage;
           ber: BerElement): pchar8; stdcall;
//LDAP_F( char * )
//ldap_next_attribute LDAP_P((
//	LDAP *ld,
//	LDAPMessage *entry,
//	BerElement *ber ));

///*
// * in free.c
// */
function ldap_memfree(
           p: pointer):ppchar8; stdcall;
//LDAP_F( void )
//ldap_memfree LDAP_P((
//	void* p ));


///*
// * in getvalues.c
// */
function ldap_get_values(
           ld: hLDAP;
           entry : LDAPMessage;
           const target: pchar8): ppchar8; stdcall;
//LDAP_F( char ** )
//ldap_get_values LDAP_P((
//	LDAP *ld,
//	LDAPMessage *entry,
//	LDAP_CONST char *target ));

function ldap_get_values_len(
           ld: hLDAP;
           entry : LDAPMessage;
           const target: pchar8): pberval; stdcall;
//LDAP_F( struct berval ** )
//ldap_get_values_len LDAP_P((
//	LDAP *ld,
//	LDAPMessage *entry,
//	LDAP_CONST char *target ));

function ldap_count_values(
            vals: ppchar8): int32; stdcall;
//LDAP_F( int )
//ldap_count_values LDAP_P((
//	char **vals ));

function ldap_count_values_len(
            vals: pberval): int32; stdcall;
//LDAP_F( int )
//ldap_count_values_len LDAP_P((
//	struct berval **vals ));

procedure ldap_value_free(
            vals: ppchar8); stdcall;
//LDAP_F( void )
//ldap_value_free LDAP_P((
//	char **vals ));

procedure ldap_value_free_len(
            vals: pberval); stdcall;
//LDAP_F( void )
//ldap_value_free_len LDAP_P((
//	struct berval **vals ));

///*
// * in result.c:
// */
function ldap_result(
           ld: hLDAP;
           msgid: integer;
           all: integer;
           var timeout: timeval;
           var result: LDAPMessage):ldapcode; stdcall;
//LDAP_F( int )
//ldap_result LDAP_P((
//	LDAP *ld,
//	int msgid,
//	int all,
//	struct timeval *timeout,
//	LDAPMessage **result ));


function ldap_msgtype(
           lm: LDAPMessage):ldapcode; stdcall;
//LDAP_F( int )
//ldap_msgtype LDAP_P((
//	LDAPMessage *lm ));

function ldap_msgid(
           lm: LDAPMessage):ldapcode; stdcall;
//LDAP_F( int )
//ldap_msgid   LDAP_P((
//	LDAPMessage *lm ));

function ldap_msgfree(
           lm: LDAPMessage):ldapcode; stdcall;
//LDAP_F( int )
//ldap_msgfree LDAP_P((
//	LDAPMessage *lm ));

///*
// * in search.c:
// */
function ldap_search_ext(
           ld: hLDAP;
           base: pchar8;
           scope: int32;
           filter: pchar8;
           attrs: array of pchar8;
           attrsonly: int32;
           serverctrls: pLDAPControl;
           clientctrls: pLDAPControl;
           var timeout: timeval;
           sizelimit: int32;
           var msgidp: int32):ldapcode; stdcall;
//LDAP_F( int )
//ldap_search_ext LDAP_P((
//	LDAP			*ld,
//	LDAP_CONST char	*base,
//	int				scope,
//	LDAP_CONST char	*filter,
//	char			**attrs,
//	int				attrsonly,
//	LDAPControl		**serverctrls,
//	LDAPControl		**clientctrls,
//	struct timeval	*timeout,
//	int				sizelimit,
//	int				*msgidp ));

function ldap_search_ext_s(
           ld: hLDAP;
           base: pchar8;
           scope: int32;
           filter: pchar8;
           attrs: ppchar8;
           attrsonly: int32;
           serverctrls: pLDAPControl;
           clientctrls: pLDAPControl;
           timeout: ptimeval;
           sizelimit: int32;
           var res : LDAPMessage):ldapcode; stdcall;
//LDAP_F( int )
//ldap_search_ext_s LDAP_P((
//	LDAP			*ld,
//	LDAP_CONST char	*base,
//	int				scope,
//	LDAP_CONST char	*filter,
//	char			**attrs,
//	int				attrsonly,
//	LDAPControl		**serverctrls,
//	LDAPControl		**clientctrls,
//	struct timeval	*timeout,
//	int				sizelimit,
//	LDAPMessage		**res ));
(*

LDAP_F( int )
ldap_search LDAP_P((	/* deprecated */
	LDAP *ld,
	LDAP_CONST char *base,
	int scope,
	LDAP_CONST char *filter,
	char **attrs,
	int attrsonly ));

LDAP_F( int )
ldap_search_s LDAP_P((	/* deprecated */
	LDAP *ld,
	LDAP_CONST char *base,
	int scope,
	LDAP_CONST char *filter,
	char **attrs,
	int attrsonly,
	LDAPMessage **res ));

LDAP_F( int )
ldap_search_st LDAP_P((	/* deprecated */
	LDAP *ld,
	LDAP_CONST char *base,
	int scope,
	LDAP_CONST char *filter,
        char **attrs,
	int attrsonly,
	struct timeval *timeout,
	LDAPMessage **res ));
*)

///*
// * in unbind.c
// */
function ldap_unbind(
           ld: hLDAP):ldapcode; stdcall;
//LDAP_F( int )
//ldap_unbind LDAP_P((
//	LDAP *ld ));

function ldap_unbind_s(
           ld: hLDAP):ldapcode; stdcall;
//LDAP_F( int )
//ldap_unbind_s LDAP_P((
//	LDAP *ld ));

(*
LDAP_F( int )
ldap_unbind_ext LDAP_P((
	LDAP			*ld,
	LDAPControl		**serverctrls,
	LDAPControl		**clientctrls));

LDAP_F( int )
ldap_unbind_ext_s LDAP_P((
	LDAP			*ld,
	LDAPControl		**serverctrls,
	LDAPControl		**clientctrls));
*)

///*
// * in sort.c
// */
function ldap_sort_entries(
           ld: hLDAP;
           VAR chain: LDAPMessage;
           attr: pchar8;
           cmp: tcmpFunc):ldapcode; stdcall;
//LDAP_F( int )
//ldap_sort_entries LDAP_P(( LDAP *ld,
//	LDAPMessage **chain,
//	LDAP_CONST char *attr,
//	int (*cmp) (LDAP_CONST char *, LDAP_CONST char * ) ));

function ldap_multisort_entries(
           ld: hLDAP;
           VAR chain: LDAPMessage;
           attr: ppchar8;
           cmp: tcmpFunc):ldapcode; stdcall;
//LDAP_F( int )
//ldap_multisort_entries LDAP_P(( LDAP *ld,
//	LDAPMessage **chain,
//	LDAP_CONST char **attrs,
//	int (*cmp) (LDAP_CONST char *, LDAP_CONST char * ) ));

function ldap_sort_values(
           ld: hLDAP;
           VAR vals: pchar8;
           cmp: tcmpFunc):ldapcode; stdcall;
//LDAP_F( int )
//ldap_sort_values LDAP_P((
//	LDAP *ld,
//	char **vals,
//	int (*cmp) (LDAP_CONST void *, LDAP_CONST void *  ));

function ldap_sort_strcasecmp(
           VAR a;
           VAR b):integer; stdcall;
//LDAP_F( int )
//ldap_sort_strcasecmp LDAP_P((
//	LDAP_CONST void *a,
//	LDAP_CONST void *b ));

(*
/*
 * in url.c
 *
 * need _ext variants
 */
LDAP_F( int )
ldap_is_ldap_url LDAP_P((
	LDAP_CONST char *url ));

LDAP_F( int )
ldap_is_ldaps_url LDAP_P((
	LDAP_CONST char *url ));

LDAP_F( int )
ldap_url_parse LDAP_P((
	LDAP_CONST char *url,
	LDAPURLDesc **ludpp ));

LDAP_F(int)
ldap_url_parse_ext LDAP_P(( 
    LDAP_CONST char *url_in, 
    LDAPURLDesc **ludpp ));

LDAP_F( char * )
ldap_url_desc2str LDAP_P((
	LDAPURLDesc *ludp ));

LDAP_F( void )
ldap_free_urldesc LDAP_P((
	LDAPURLDesc *ludp ));

LDAP_F( int )
ldap_url_search LDAP_P((
	LDAP *ld,
	LDAP_CONST char *url,
	int attrsonly ));

LDAP_F( int )
ldap_url_search_s LDAP_P((
	LDAP *ld,
	LDAP_CONST char *url,
	int attrsonly,
	LDAPMessage **res ));

LDAP_F( int )
ldap_url_search_st LDAP_P((
	LDAP *ld,
	LDAP_CONST char *url,
	int attrsonly,
	struct timeval *timeout,
	LDAPMessage **res ));

/*
 * in digestmd5.c
 */

typedef struct digestMD5ctx LDAP_DIGEST_MD5_CONTEXT;

LDAP_F(int)
ldap_bind_digest_md5_start LDAP_P((
    LDAP                      *ld,
    LDAP_DIGEST_MD5_CONTEXT   **pMD5Context));

LDAP_F(int)
ldap_get_digest_md5_realms LDAP_P((
	LDAP_DIGEST_MD5_CONTEXT		*MD5context,
	char                        ***realms));


/* defines for the abortFlag parameter */
        LDAP_DIGEST_MD5_FINISH  1
        LDAP_DIGEST_MD5_ABORT   2

LDAP_F( int )
ldap_bind_digest_md5_finish LDAP_P(( 
	LDAP_DIGEST_MD5_CONTEXT	  **pMD5context,
	char 					  *authID,
	char   					  *password,
    int                       passwordLen,
	int                       realmIndex,
	int                       abortFlag));

/*
 * in nmas.c
 */

LDAP_F(int)
ldap_bind_nmas_s(
	LDAP				*ld,
	LDAP_CONST char  	*dn,
	LDAP_CONST char 	*password,
	LDAP_CONST char 	*reqSequence,
	LDAP_CONST char 	*reqClearance);

/*
 * in sortctrl.c
 */
/*
 * structure for a sort-key 
 */
typedef struct ldapsortkey {
	char *  attributeType;
	char *  orderingRule;
	int     reverseOrder;
} LDAPSortKey;

LDAP_F( int )
ldap_create_sort_keylist LDAP_P((
	LDAPSortKey ***sortKeyList,
	char        *keyString ));

LDAP_F( void )
ldap_free_sort_keylist LDAP_P((
	LDAPSortKey **sortkeylist ));



LDAP_F( int )
ldap_create_sort_control LDAP_P((
     LDAP *ld, 
     LDAPSortKey **keyList,
     int ctl_iscritical,
     LDAPControl **ctrlp));

LDAP_F( int )
ldap_parse_sort_control LDAP_P((
      LDAP           *ld, 
      LDAPControl    **ctrlp,  
      unsigned long  *result,
      char           **attribute));

/*
 * in psearchctrl.c
 */
        LDAP_CHANGETYPE_ADD		1
        LDAP_CHANGETYPE_DELETE		2
        LDAP_CHANGETYPE_MODIFY		4
        LDAP_CHANGETYPE_MODDN		8
        LDAP_CHANGETYPE_ANY		(1|2|4|8)
LDAP_F( int )
ldap_create_persistentsearch_control LDAP_P((
    LDAP        *ld, 
    int         changeTypes,
    int         changesOnly, 
    int         returnEchgCtls,
    char        isCritical, 
    LDAPControl **ctrlp ));

LDAP_F( int )
ldap_parse_entrychange_control LDAP_P((
    LDAP        *ld, 
    LDAPControl **ctrls, 
    int         *changeType,
    char        **prevDN,
    int         *hasChangeNum,
    long        *changeNum ));

/*
 * in vlvctrl.c  
 */

/*
 * structure for virtul list.
 */
typedef struct ldapvlvinfo {
	int             ldvlv_version;
    unsigned long   ldvlv_before_count;
    unsigned long   ldvlv_after_count;
    unsigned long   ldvlv_offset;
    unsigned long   ldvlv_count;
    struct berval  *ldvlv_attrvalue;
    struct berval  *ldvlv_context;
    void           *ldvlv_extradata;
} LDAPVLVInfo;

LDAP_F( int ) 
ldap_create_vlv_control LDAP_P((
	LDAP *ld, 
	LDAPVLVInfo *ldvlistp,
	LDAPControl **ctrlp ));

LDAP_F( int )
ldap_parse_vlv_control LDAP_P(( 
	LDAP          *ld,
	LDAPControl   **ctrls,
	unsigned long *target_posp, 
	unsigned long *list_countp, 
	struct berval **contextp,
	int           *errcodep ));

*)
///*  These structures and functions are defined in
//    Schema_util.h and implemented in Schema_util.c */

///* structures */
type
//typedef struct ldap_schema_element LDAPSchemaElement;
//   LDAPSchemaElement = ldap_schema_element;
     pLDAPSchemaElement = pointer;

// typedef struct ldap_schema LDAPSchema;
     pLDAPSchema = pointer;

///* Holds field names and values of an attribute definition. External */
//typedef struct ldap_schema_mod {
//	int op;  			/* same type define as LDAPMod:
//						LDAP_MOD_ADD, LDAP_MOD_REPLACE, LDAP_MOD_DELETE */
//	char *fieldName;	/* name of the field to update or add*/
//	char **values;		/* Values of the field.  */
//
//} LDAPSchemaMod;
     LDAPSchemaMod = record
       op: integer;
       fieldName: pchar8;
       values: ppchar8;
     end;
     pLDAPSchemaMod = ^LDAPSchemaMod;

//* macros */
const   LDAP_SCHEMA_ATTRIBUTE_TYPE     = 0;
        LDAP_SCHEMA_OBJECT_CLASS       = 1;
        LDAP_SCHEMA_SYNTAX             = 2;
        LDAP_SCHEMA_MATCHING_RULE      = 3;
        LDAP_SCHEMA_MATCHING_RULE_USE  = 4;
        LDAP_SCHEMA_NAME_FORM          = 5;
        LDAP_SCHEMA_DIT_CONTENT_RULE   = 6;
        LDAP_SCHEMA_DIT_STRUCTURE_RULE = 7;


//****************************************************************/
//*   Table of fields for SchemaElements (repeats are commented) */
//*                                                              */
//*      NAME                              Value                 */
//*--------------------------------------------------------------*/
//*     All types, except DITStructureRule does not have an OID  */
                LDAP_SCHEMA_OID             = 'OID';
                LDAP_SCHEMA_DESCRIPTION     = 'DESC';
//*     All but LDAPSchemaSyntax  */
                LDAP_SCHEMA_NAMES           = 'NAME';
//*           LDAP_SCHEMA_VALUE                                */
                LDAP_SCHEMA_OBSOLETE        = 'OBSOLETE';

//*     LDAPSchemaAttributeType   */
                LDAP_SCHEMA_SUPERIOR        = 'SUP';
                LDAP_SCHEMA_EQUALITY        = 'EQUALITY';
                LDAP_SCHEMA_ORDERING        = 'ORDERING';
                LDAP_SCHEMA_SUBSTRING       = 'SUBSTR';
                LDAP_SCHEMA_SYNTAX_OID      = 'SYNTAX';
                LDAP_SCHEMA_SINGLE_VALUED   = 'SINGLE-VALUE';
                LDAP_SCHEMA_COLLECTIVE      = 'COLLECTIVE';
                LDAP_SCHEMA_NO_USER_MOD     = 'NO-USER-MODIFICATION';
                LDAP_SCHEMA_USAGE           = 'USAGE';

//*     LDAPSchemaObjectClass                                */
                LDAP_SCHEMA_SUPERIORS       = 'SUP';
                LDAP_SCHEMA_MUST_ATTRIBUTES = 'MUST';
                LDAP_SCHEMA_MAY_ATTRIBUTES  = 'MAY';

                LDAP_SCHEMA_TYPE_ABSTRACT   = 'ABSTRACT';
                LDAP_SCHEMA_TYPE_STRUCTURAL = 'STRUCTURAL';
                LDAP_SCHEMA_TYPE_AUXILIARY  = 'AUXILIARY';

 //*     LDAPSchemaMatchingRule                               */
//              LDAP_SCHEMA_SYNTAX_OID      = 'SYNTAX';

//*     LDAPSchemaMatchingRuleUse                            */
                LDAP_SCHEMA_APPLIES         = 'APPLIES';

//*     LDAPSchemaNameForm                                   */
                LDAP_SCHEMA_NAME_FORM_OBJECT= 'OC';
//*             LDAP_SCHEMA_MUST_ATTRIBUTES = 'MUST';      required
//              LDAP_SCHEMA_MAY_ATTRIBUTES  = 'MAY';         */

//*     LDAPSchemaSyntax                                     */
//*             LDAP_SCHEMA_OID             = 'OID';         */
//*             LDAP_SCHEMA_DESCRIPTION     = 'DESC';        */

//*     LDAPSchemaDITContentRule                             */
                LDAP_SCHEMA_AUX_CLASSES    = 'AUX';
//*             LDAP_SCHEMA_MUST_ATTRIBUTES= 'MUST';
//              LDAP_SCHEMA_MAY_ATTRIBUTES = 'MAY';          */
                LDAP_SCHEMA_NOT_ATTRIBUTES = 'NOT';

//*     LDAPSchemaDITStructureRule : Does not contain OID    */
                LDAP_SCHEMA_RULE_ID        = 'RULEID';
                LDAP_SCHEMA_NAME_FORM_OID  = 'FORM';
//*            LDAP_SCHEMA_SUPERIORS       = 'SUP';          */


//* for use with the field LDAP_SCHEMA_USAGE */
        LDAP_SCHEMA_USER_APP               = 'userApplications';
        LDAP_SCHEMA_DIRECTORY_OP           = 'directoryOperation';
        LDAP_SCHEMA_DISTRIBUTED_OP         = 'distributedOperation';
        LDAP_SCHEMA_DSA_OP                 = 'dSAOperation';

//****************************************************************
//Functions to init and free the local copy of Directory schema:
//*/

 (* Fetches directory schema and stores it in a local read-only
    copy. *)
function ldap_schema_fetch(
           ld: hLDAP;
           var schema: pLDAPSchema;
           subschemaSubentryDN: pchar8):ldapcode; stdcall;
//    LDAP_F( int )
//    ldap_schema_fetch LDAP_P((
//            struct ldap *ld,
//            struct ldap_schema **schema,
//            const char* subschemaSubentryDN ));

  (* Frees memory allocated to it from ldap_schema_fetch *)
function ldap_schema_free(
           schema: pLDAPSchema):ldapcode; stdcall;
//    LDAP_F( int )
//    ldap_schema_free LDAP_P((
//            struct ldap_schema *schema));


///****************************************************************
//Locating individual schema elements:
//*/

	(* Retrieves the schema element according to name and type *)
function ldap_schema_get_by_name(
           schema: pLDAPSchema;
           name: pchar8;
           elementType: integer;
           var element: pLDAPSchemaElement):ldapcode; stdcall;
//    LDAP_F( int )
//    ldap_schema_get_by_name  LDAP_P((
//            struct ldap_schema* schema,
//            char* name,
//            int elementType,
//            struct ldap_schema_element **element));

	(* 	Retrieves the schema element according to an index and type *)
function ldap_schema_get_by_index(
           schema: pLDAPSchema;
           index: integer;
           elementType: integer;
           var element: pLDAPSchemaElement):ldapcode; stdcall;
//    LDAP_F( int )
//    ldap_schema_get_by_index LDAP_P((
//            struct ldap_schema* schema,
//            int index,
//            int elementType,
//            struct ldap_schema_element **element));

	(* 	Returns the number of elements of a type.  This is to be used
        in conjunction with get_by_index *)
function ldap_schema_get_count(
           schema: pLDAPSchema;
           elementType: integer):integer; stdcall;
//    LDAP_F( int )
//    ldap_schema_get_count LDAP_P((
//            struct ldap_schema* schema,
//            int elementType));

///*****************************************************************
//Extracting information from schema elements:
//*/
    (*  Retrieves a list of the fields defined for this schema element *)
function ldap_schema_get_field_names(
           schema: pLDAPSchemaElement;
           var names: ppchar8):ldapcode; stdcall;
//    LDAP_F( int )
//    ldap_schema_get_field_names LDAP_P((
//	    LDAPSchemaElement *schema,
//	    char ***names ));

    (*  Retrieves a list of values for the specified field in this schema
	    element *)
function ldap_schema_get_field_values(
           schema: pLDAPSchemaElement;
           name: pchar8;
           var values: ppchar8):ldapcode; stdcall;
//    LDAP_F( int )
//    ldap_schema_get_field_values LDAP_P((
//	    LDAPSchemaElement *schema,
//	    char *name,
//	    char ***values ));
    (* Use ldap_value_free for names and values *)



///*****************************************************************
//Changing schema definitions
//*/

    (* 	Deletes the schema element definition identifed by the string
	    name_oid from the LDAPSchema structure.  If a Name is given
        then the type is used to identify which element type the
        element is to be deleted from. *)
function ldap_schema_delete(
           schema: pLDAPSchema;
           ldtype: integer;
           name_oid: pchar8):ldapcode; stdcall;
//    LDAP_F( int )
//    ldap_schema_delete LDAP_P((
//	    LDAPSchema *schema,
//	    int type,
//        char *name_oid));

    (*	Modifies the fields of a schema element.  Each mod structure in
        the fieldsToChange array will have a flag to specify a delete,
	    replace or add.  The schema element is identified by name_oid.
	    The change is reflected in the LDAPSchema structure *)
function ldap_schema_modify(
           schema: pLDAPSchema;
           name_oid: pchar8;
           ldtype: integer;
           fieldsToChange: pLDAPSchemaMod):ldapcode; stdcall;
//    LDAP_F( int )
//    ldap_schema_modify LDAP_P((
//	    LDAPSchema *schema,
//	    char* name_oid,
//	    int type,
//	    struct ldap_schema_mod *fieldsToChange[]));

    (*	Adds a new schema element definition to the LDAPSchema structure *)
function ldap_schema_add(
           schema: pLDAPSchema;
           ldtype: integer;
           fields: pLDAPSchemaMod):ldapcode; stdcall;
//    LDAP_F( int )
//    ldap_schema_add LDAP_P((
//	    LDAPSchema *schema,
//	    int type,
//	    struct ldap_schema_mod *fields[]));

    (*  Saves any changes made in the LDAPSchema structure from the
        functions ldap_schema_add, ldap_schema_modify, and
        ldap_schema_delete. If the DN of the subschemaSubentry to use is
        NULL, the first Subentry advertized in the Root DSE will be used.
        (LDAPv3 must be set to read the root DSE.) *)
function ldap_schema_save(
           ld: hLDAP;
           schema: pLDAPSchema;
           subschemaSubentryDN: pchar8):ldapcode; stdcall;
//    LDAP_F( int )
//    ldap_schema_save LDAP_P((
//        LDAP *ld,
//        LDAPSchema *schema,
//        const char *subschemaSubentryDN ));

///*
// * in cancel.c
// */

///*
// * functions for cancel operation.
// */
function ldap_cancel_ext(
           ld: hLDAP;
           cancelid: integer;
           sctrls: pLDAPControl;
           cctrls: pLDAPControl;
           var msgidp: integer):ldapcode; stdcall;
//LDAP_F(int)
//ldap_cancel_ext(
//	LDAP            *ld,
//	int             cancelid,
//	LDAPControl     **sctrls,
//	LDAPControl     **cctrls,
//	int             *msgidp );

function ldap_cancel_ext_s(
           ld: hLDAP;
           cancelid: integer;
           sctrls: pLDAPControl;
           cctrls: pLDAPControl):ldapcode; stdcall;
//LDAP_F(int)
//ldap_cancel_ext_s(
//	LDAP            *ld,
//	int             cancelid,
//	LDAPControl     **sctrls,
//	LDAPControl     **cctrls );

implementation

// * in loptions.c:
function ldap_get_option;              external 'LDAPSDK.DLL';
function ldap_set_option;              external 'LDAPSDK.DLL';
// * in add.c:
function ldap_add_ext;                 external 'LDAPSDK.DLL';
function ldap_add_ext_s;               external 'LDAPSDK.DLL';
//  * in sasl.c
function ldap_sasl_bind_s;             external 'LDAPSDK.DLL';
function ldap_parse_sasl_bind_result;  external 'LDAPSDK.DLL';
// * in sbind.c:
function ldap_simple_bind;             external 'LDAPSDK.DLL';
function ldap_simple_bind_s;           external 'LDAPSDK.DLL';
// * in delete.c:
function ldap_delete_ext;              external 'LDAPSDK.DLL';
function ldap_delete_ext_s;            external 'LDAPSDK.DLL';
// * in error.c:
function ldap_err2string;              external 'LDAPSDK.DLL';
// * in modify.c:
function ldap_modify_ext;              external 'LDAPSDK.DLL';
function ldap_modify_ext_s;            external 'LDAPSDK.DLL';
// * in modrdn.c:
function ldap_rename;                  external 'LDAPSDK.DLL';
function ldap_rename_s;                external 'LDAPSDK.DLL';
// * in open.c:
function ldap_init;                    external 'LDAPSDK.DLL';
function ldap_destroy;                 external 'LDAPSDK.DLL';
function ldap_dup;                     external 'LDAPSDK.DLL';
// * in getentry.c:
function ldap_first_entry;             external 'LDAPSDK.DLL';
function ldap_next_entry;              external 'LDAPSDK.DLL';
function ldap_count_entries;           external 'LDAPSDK.DLL';
function ldap_get_entry_controls;      external 'LDAPSDK.DLL';
// * in getdn.c
function ldap_get_dn;                  external 'LDAPSDK.DLL';
function ldap_dn2ufn;                  external 'LDAPSDK.DLL';
function ldap_explode_dn;              external 'LDAPSDK.DLL';
function ldap_explode_rdn;             external 'LDAPSDK.DLL';
// * in getattr.c
function ldap_first_attribute;         external 'LDAPSDK.DLL';
function ldap_next_attribute;          external 'LDAPSDK.DLL';
// * in free.c
function ldap_memfree;                 external 'LDAPSDK.DLL';
// * in getvalues.c
function ldap_get_values;              external 'LDAPSDK.DLL';
function ldap_get_values_len;          external 'LDAPSDK.DLL';
function ldap_count_values;            external 'LDAPSDK.DLL';
function ldap_count_values_len;        external 'LDAPSDK.DLL';
procedure ldap_value_free;             external 'LDAPSDK.DLL';
procedure ldap_value_free_len;         external 'LDAPSDK.DLL';
// * in result.c:
function ldap_result;                  external 'LDAPSDK.DLL';
function ldap_msgtype;                 external 'LDAPSDK.DLL';
function ldap_msgid;                   external 'LDAPSDK.DLL';
function ldap_msgfree;                 external 'LDAPSDK.DLL';
// * in search.c:
function ldap_search_ext;              external 'LDAPSDK.DLL';
function ldap_search_ext_s;            external 'LDAPSDK.DLL';
//function ldap_search;                  external 'LDAPSDK.DLL';
//function ldap_search_s;                external 'LDAPSDK.DLL';
//function ldap_search_st;               external 'LDAPSDK.DLL';
// * in unbind.c
function ldap_unbind;                  external 'LDAPSDK.DLL';
function ldap_unbind_s;                external 'LDAPSDK.DLL';
// * in sort.c
function ldap_sort_entries;            external 'LDAPSDK.DLL';
function ldap_multisort_entries;       external 'LDAPSDK.DLL';
function ldap_sort_values;             external 'LDAPSDK.DLL';
function ldap_sort_strcasecmp;         external 'LDAPSDK.DLL';
// * in Schema_util.c                  
function ldap_schema_fetch;            external 'LDAPSDK.DLL';
function ldap_schema_free;             external 'LDAPSDK.DLL';
function ldap_schema_get_by_name;      external 'LDAPSDK.DLL';
function ldap_schema_get_by_index;     external 'LDAPSDK.DLL';
function ldap_schema_get_count;        external 'LDAPSDK.DLL';
function ldap_schema_get_field_names;  external 'LDAPSDK.DLL';
function ldap_schema_get_field_values; external 'LDAPSDK.DLL';
function ldap_schema_delete;           external 'LDAPSDK.DLL';
function ldap_schema_modify;           external 'LDAPSDK.DLL';
function ldap_schema_add;              external 'LDAPSDK.DLL';
function ldap_schema_save;             external 'LDAPSDK.DLL';
// * in cancel.c
function ldap_cancel_ext;              external 'LDAPSDK.DLL';
function ldap_cancel_ext_s;            external 'LDAPSDK.DLL';

end.

